/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023  SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.towerrun.state;

import java.util.EnumSet;

public abstract class GameStateToggleListener extends GameStateListener {

    private final EnumSet<GameStates> enabledStates;

    protected GameStateToggleListener(EnumSet<GameStates> enabledStates) {
        super();
        this.enabledStates = enabledStates;
        if (enabledStates.contains(GameState.getCurrentState())) {
            enable();
        }
    }

    public abstract void enable();

    public abstract void disable();

    @Override
    public void onGameStateChange(GameStates oldState, GameStates newState) {
        if (enabledStates.contains(newState) && !enabledStates.contains(oldState)) {
            enable();
        } else if (!enabledStates.contains(newState) && enabledStates.contains(oldState)) {
            disable();
        }
    }
}
